//  Building Parts, Doors, Windows Etc.  for application on Buildings
//  mainpart.inc
//  August, 1998
//  Robert J Becraft
//

#declare Door1=union{
      box{<-.1,0,-.5><.1,2.5,.5> texture{T_Wood18 scale .1}}
      box{<-.5,0,-.55><.5,.25,.55> texture{pigment{color Wheat}}}
      box{<-.7,-.25,-.75><.7,0,.75> texture{pigment{color Wheat}}}
      box{<-.15,0,-.6><.15,2.6,-.5> texture{pigment{color White}}}
      box{<-.15,0,.6><.15,2.6,.5> texture{pigment{color White}}}
      box{<-.15,2.5,-.6><.15,2.6,.6> texture{pigment{color White}}}
}

#declare Window1=union{
      box{<-.15,.5,-.55><.15,2.05,-.5> texture{pigment{color White}}}
      box{<-.15,.5,.55><.15,2.05,.5> texture{pigment{color White}}}

      box{<-.15,2.,-.55><.15,2.05,.55> texture{pigment{color White}}}
      box{<-.15,.45,-.55><.15,.5,.55> texture{pigment{color White}}}

      box{<-.1,.5,-.025><.1,2,.025> texture{pigment{color White}}}
      box{<-.1,1.225,-.5><.1,1.275,.5> texture{pigment{color White}}}

      box{<-.01,.5,-.5><.01,2,.5> texture{pigment{color Black}}}   // glass
}

#declare Barrel=union{
   cylinder{<0,-.25,0><0,.25,0>.4 texture{pigment{color Tan}}}
   difference{
     union{
       cone{<0,-.25,0>.4<0,-.5,0>.33 texture{pigment{color Tan}}}
       cylinder{<0,-.47,0><0,-.499,0>,.34 texture{pigment{color Brown}}}
     }
     cylinder{<0,-.45,0><0,-.51,0>.31 texture{pigment{color Tan}}}
     
   }
   difference{
     union{
        cone{<0,.25,0>.4<0,.5,0>.33 texture{pigment{color Tan}}}
        cylinder{<0,.47,0><0,.499,0>,.34 texture{pigment{color Brown}}}
     }
     cylinder{<0,.45,0><0,.51,0>,.33 texture{pigment{color Tan}}}
   }
   cylinder{<0,-.25,0><0,-.28,0>,.41 texture{pigment{color Brown}}}
   cylinder{<0,.25,0><0,.28,0>,.41 texture{pigment{color Brown}}}
   cylinder{<0,-.45,.23><0,-.48,.23>.05 texture{pigment{color Brown}}}
}

#declare BarrelStack=union{
   object{Barrel rotate<0,0,90> translate<0,0,1.6>}
   object{Barrel rotate<0,0,90> translate<0,0,.8>}
   object{Barrel rotate<0,0,90> translate<0,0,0>}
   object{Barrel rotate<0,0,90> translate<0,0,-.8>}
   object{Barrel rotate<0,0,90> translate<0,0,-1.6>}

   object{Barrel rotate<0,0,90> translate<0,.57,1.2>}
   object{Barrel rotate<0,0,90> translate<0,.57,.4>}
   object{Barrel rotate<0,0,90> translate<0,.57,-.4>}
   object{Barrel rotate<0,0,90> translate<0,.57,-1.2>}

   object{Barrel rotate<0,0,90> translate<0,1.24,.8>}
   object{Barrel rotate<0,0,90> translate<0,1.24,0>}
   object{Barrel rotate<0,0,90> translate<0,1.24,-.8>}
}
#declare Bark_Cargo=union{
   object{BarrelStack}
   object{BarrelStack translate<1.4,0,0>}
   object{BarrelStack translate<-1.4,0,0>}
}

#declare BarrelSmall=object{Barrel scale .5}
#declare Basket=difference{
   cone{<0,0,0>,.25 <0,.5,0>,.35 texture{pigment{color Wheat}}}
   cone{<0,.04,0>,.24 <0,.51,0>,.34 texture{pigment{color Wheat}}}
}
#declare Box1=union{
   box{<-.5,0,-.25><.5,.25,.25> texture{pigment{color Tan}}}
   box{<-.4,0,-.27><-.35,.27,.27> texture{pigment{color Tan}}}
   box{<.35,.27,-.27><.4,.27,.27> texture{pigment{color Tan}}}
}
#declare BoxStack=union{
   object{Box1}
   object{Box1 rotate<0,10,0> translate<0,.27,0>}
   object{Box1 translate<0,0,-.3>}
   object{Box1 rotate<0,-5,0> translate<0,.54,0>}
}
